require "option_parser"
require "./src/specfileparser"

recipe_file_name = "some-non-existant-file"

OptionParser.parse! do |parser|
	parser.on "-f file", "--file file", "File to parse." do |f|
		recipe_file_name = f
	end

	parser.on "-h", "--help", "Show this help" do
		puts parser
		exit 0
	end
end


options = Hash(String,String).new
options["someoptionexample"] = "option"

specs = SpecFileParser.parse recipe_file_name, options
pp! specs





# low level stuff

sectioncontainer = SpecFileParser::Section.new "val"
begin
	puts sectioncontainer.as_s
	puts "(NOT OK) SpecFileParser::Section should not accept .as_s"
rescue e
	puts "(OK) #{e}"
end
begin
	pp! sectioncontainer.as_a_or_s
	puts "(NOT OK) SpecFileParser::Section should not accept .as_a_or_s"
rescue e
	puts "(OK) #{e}"
end

arraycontainer = SpecFileParser::ArrayContainer.new Array(String).new.push "value"
begin
	puts arraycontainer.as_s
	puts "(NOT OK) SpecFileParser::ArrayContainer should not accept .as_s"
rescue e
	puts "(OK) #{e}"
end
begin
	pp! arraycontainer.as_a_or_s
	puts "(OK) SpecFileParser::ArrayContainer should accept .as_a_or_s"
rescue e
	puts "(NOT OK) #{e}"
end
